package org.beetl.sql.core.nosql;

import org.beetl.sql.core.SQLManager;
import org.beetl.sql.core.db.AbstractDBStyle;
import org.beetl.sql.core.db.DBType;
import org.beetl.sql.core.mapping.type.JavaSqlTypeHandler;
import org.beetl.sql.core.mapping.type.ReadTypeParameter;
import org.beetl.sql.core.mapping.type.WriteTypeParameter;
import org.beetl.sql.core.range.OffsetLimitRange;
import org.beetl.sql.core.range.RangeSql;

import java.sql.Date;
import java.sql.SQLException;
import java.util.Collection;
import java.util.Map;

/**
 *
 * @author xiandafu
 * @see "http://endoc.machbase.com/display/MANUAL/JDBC"
 * @see "https://hub.docker.com/r/machbase/machbase"
 * @see "http://endoc.machbase.com/display/MANUAL/Creation+and+Dropping+of+Tag+table"
 *
 */
public class MachbaseStyle  extends AbstractDBStyle {

    RangeSql rangeSql = null;
    public MachbaseStyle() {
        super();
        //同mysql
        rangeSql = new OffsetLimitRange(this);
    }

    @Override
    public int getIdType(Class c,String idProperty) {
        //只支持
        return DBType.ID_ASSIGN;
    }

    @Override
    public boolean  isNoSql(){
        return true;
    }
    @Override
    public String getName() {
        return "clickhouse";
    }

    @Override
    public int getDBType() {
        return DBType.DB_CLICKHOUSE;
    }

    @Override
    public RangeSql getRangeSql() {
        return rangeSql;
    }

    protected void checkId(Collection colsId, Collection attrsId, String clsName) {
        // 不检测主键
        return ;
    }

//    public void config(SQLManager sqlManager){
//        Map<Class, JavaSqlTypeHandler> handlerMap = sqlManager.getDefaultBeanProcessors().getHandlers();
//        handlerMap.put(java.util.Date.class,new ClickHouseStyle.UtilDateTypeHandler() );
//        handlerMap.put(java.sql.Date.class,new ClickHouseStyle.SQlDateTypeHandler() );
//    }
//
//    public static class SQlDateTypeHandler extends JavaSqlTypeHandler {
//        @Override
//        public Object getValue(ReadTypeParameter typePara) throws SQLException {
//            Date a = typePara.getRs().getDate(typePara.getIndex());
//            return a;
//        }
//
//        @Override
//        public void setParameter(WriteTypeParameter writeTypeParameter, Object obj)throws SQLException {
//            writeTypeParameter.getPs().setDate(writeTypeParameter.getIndex(),(java.sql.Date)obj);
//        }
//
//    }
//
//    public static class UtilDateTypeHandler extends JavaSqlTypeHandler {
//        @Override
//        public Object getValue(ReadTypeParameter typePara) throws SQLException {
//            Date a = typePara.getRs().getDate(typePara.getIndex());
//            return new java.util.Date(a.getTime());
//        }
//
//        @Override
//        public void setParameter(WriteTypeParameter writeTypeParameter, Object obj)throws SQLException {
//            java.util.Date date = (java.util.Date)obj;
//            writeTypeParameter.getPs().setDate(writeTypeParameter.getIndex(),new java.sql.Date(date.getTime()));
//        }
//
//    }

}
